diff --git b/hung_patch_from_arnt/aox/db/query.cpp a/instrumentation/aox/db/query.cpp
index 85f7aae..966e495 100644
--- b/hung_patch_from_arnt/aox/db/query.cpp
+++ a/instrumentation/aox/db/query.cpp
@@ -562,7 +562,7 @@ void Query::notify()
     try {
         d->owner->execute();
     }
-    catch ( const Exception& e ) {
+    catch ( Exception e ) {
         d->owner = 0; // so we can't get close to a segfault again
         if ( e == Invariant ) {
             setError( "Invariant failed while processing Query::notify()" );
@@ -599,7 +599,7 @@ void Query::notify()
             }
         }
         else {
-            throw;
+            throw e;
         }
     }
 }
diff --git b/hung_patch_from_arnt/aox/db/transaction.cpp a/instrumentation/aox/db/transaction.cpp
index 73bab8d..a85a7b5 100644
--- b/hung_patch_from_arnt/aox/db/transaction.cpp
+++ a/instrumentation/aox/db/transaction.cpp
@@ -609,7 +609,7 @@ void Transaction::notify()
     try {
         d->owner->execute();
     }
-    catch ( const Exception& e ) {
+    catch ( Exception e ) {
         d->owner = 0; // so we can't get close to a segfault again
         if ( e == Invariant ) {
             setError( 0,
@@ -633,7 +633,7 @@ void Transaction::notify()
             }
         }
         else {
-            throw;
+            throw e;
         }
     }
     if ( done() && d->parent &&
diff --git b/hung_patch_from_arnt/aox/imap/handlers/copy.cpp a/instrumentation/aox/imap/handlers/copy.cpp
index 1882b07..a94ddb7 100644
--- b/hung_patch_from_arnt/aox/imap/handlers/copy.cpp
+++ a/instrumentation/aox/imap/handlers/copy.cpp
@@ -121,8 +121,6 @@ void Copy::execute()
         if ( (uint)r->getInt( "id" ) == d->mailbox->id() ) {
             d->toUid = r->getInt( "uidnext" );
             d->toMs = r->getBigint( "nextmodseq" );
-            if ( session()->mailbox() == d->mailbox )
-                d->fromMs = d->toMs;
         }
         else {
             d->fromMs = r->getBigint( "nextmodseq" );
diff --git b/hung_patch_from_arnt/aox/imap/handlers/fetch.cpp a/instrumentation/aox/imap/handlers/fetch.cpp
index 3ff887a..30e0c82 100644
--- b/hung_patch_from_arnt/aox/imap/handlers/fetch.cpp
+++ a/instrumentation/aox/imap/handlers/fetch.cpp
@@ -154,7 +154,7 @@ Fetch::Fetch( bool u )
     of \\a t.
 */
 
-Fetch::Fetch( bool f, bool a, bool v, const IntegerSet & set,
+Fetch::Fetch( bool f, bool a, const IntegerSet & set,
               int64 limit, IMAP * i, Transaction * t )
     : Command( i ), d( new FetchData )
 {
@@ -166,27 +166,19 @@ Fetch::Fetch( bool f, bool a, bool v, const IntegerSet & set,
     d->set = set;
     d->changedSince = limit;
     d->modseq = i->clientSupports( IMAP::Condstore );
-    d->vanished = v;
     if ( t )
         setTransaction( t->subTransaction( this ) );
 
     d->peek = true;
 
-    Transaction * parent = t;
-    while( parent && parent->parent() )
-        parent = parent->parent();
-
     List<Command>::Iterator c( i->commands() );
     while ( c && c->state() == Command::Retired )
         ++c;
     while ( c && c->tag().isEmpty() )
         ++c;
-    if ( c &&
-         ( ( parent && parent == c->transaction() ) || c->group() > 0 ) &&
-         ( c->state() == Command::Blocked ||
-           c->state() == Command::Finished ||
-           c->state() == Command::Executing ) ) {
-        log( EString("Inserting flag update for modseq>") + fn( limit ) +
+    if ( c && c->group() > 0 && ( c->state() == Command::Finished ||
+                                  c->state() == Command::Executing ) ) {
+        log( "Inserting flag update for modseq>" + fn( limit ) +
              " and UIDs " + set.set() + " before " +
              c->tag() + " " + c->name() );
         i->commands()->insert( c, this );
@@ -200,6 +192,7 @@ Fetch::Fetch( bool f, bool a, bool v, const IntegerSet & set,
     }
 
     setAllowedState( IMAP::Selected );
+    setState( Executing );
 }
 
 
@@ -751,14 +744,12 @@ void Fetch::execute()
                     d->those->setString( s );
                 }
                 enqueue( d->those );
+                d->set.clear();
+                if ( transaction() )
+                    transaction()->execute();
             }
         }
-        if ( transaction() )
-            transaction()->execute();
         if ( d->those ) {
-            if ( !d->those->done() )
-                return;
-            d->set.clear();
             Row * r;
             while ( d->those->hasResults() ) {
                 r = d->those->nextRow();
@@ -775,6 +766,8 @@ void Fetch::execute()
                     d->dynamics.insert( uid, dd );
                 }
             }
+            if ( !d->those->done() )
+                return;
         }
         else {
             IntegerSet r( d->set );
diff --git b/hung_patch_from_arnt/aox/imap/handlers/fetch.h a/instrumentation/aox/imap/handlers/fetch.h
index b749ed5..17351d5 100644
--- b/hung_patch_from_arnt/aox/imap/handlers/fetch.h
+++ a/instrumentation/aox/imap/handlers/fetch.h
@@ -21,7 +21,7 @@ class Fetch
 {
 public:
     Fetch( bool = false );
-    Fetch( bool, bool, bool, const IntegerSet &, int64, IMAP *, Transaction * );
+    Fetch( bool, bool, const IntegerSet &, int64, IMAP *, Transaction * );
 
     void parse();
     void execute();
diff --git b/hung_patch_from_arnt/aox/imap/handlers/select.cpp a/instrumentation/aox/imap/handlers/select.cpp
index b16ac71..376cd78 100644
--- b/hung_patch_from_arnt/aox/imap/handlers/select.cpp
+++ a/instrumentation/aox/imap/handlers/select.cpp
@@ -25,10 +25,11 @@ public:
     SelectData()
         : readOnly( false ), annotate( false ), condstore( false ),
           needFirstUnseen( false ), unicode( false ), qresync( false ),
-          firstUnseen( 0 ), allFlags( 0 ), updated( 0 ),
+          firstUnseen( 0 ), allFlags( 0 ), vanished( 0 ),
           mailbox( 0 ), session( 0 ), permissions( 0 ),
-          cacheFirstUnseen( 0 ),
-          lastUidValidity( 0 ), lastModSeq( 0 ), firstFetch( 0 )
+          cacheFirstUnseen( 0 ), sessionPreloader( 0 ),
+          lastUidValidity( 0 ), lastModSeq( 0 ),
+          firstFetch( 0 )
     {}
 
     bool readOnly;
@@ -39,11 +40,12 @@ public:
     bool qresync;
     Query * firstUnseen;
     Query * allFlags;
-    Query * updated;
+    Query * vanished;
     Mailbox * mailbox;
     ImapSession * session;
     Permissions * permissions;
     Query * cacheFirstUnseen;
+    SessionPreloader * sessionPreloader;
     uint lastUidValidity;
     uint lastModSeq;
     IntegerSet knownUids;
@@ -228,19 +230,52 @@ void Select::execute()
             d->readOnly = true;
     }
 
-    if ( d->lastModSeq < 1 )
-        d->lastModSeq = d->mailbox->nextModSeq() - 1;
-
     if ( !transaction() )
         setTransaction( new Transaction( this ) );
 
     if ( !::firstUnseenCache )
         ::firstUnseenCache = new SelectData::FirstUnseenCache;
 
+    if ( mailboxGroup() && !d->sessionPreloader ) {
+        d->sessionPreloader = new SessionPreloader( mailboxGroup()->contents(),
+                                                    this );
+        d->sessionPreloader->execute();
+
+        IntegerSet s;
+        List<Mailbox>::Iterator i( mailboxGroup()->contents() );
+        while ( i ) {
+            if ( !::firstUnseenCache->find( i, i->nextModSeq() ) )
+                s.add( i->id() );
+            ++i;
+        }
+        if ( s.count() > 2 ) {
+            d->cacheFirstUnseen
+                = new Query( "select min(uid) as uid, mailbox, "
+                             "max(modseq) as modseq "
+                             "from mailbox_messages mm "
+                             "where mailbox=any($1) and not seen "
+                             "group by mailbox", this );
+            d->cacheFirstUnseen->bind( 1, s );
+            transaction()->enqueue( d->cacheFirstUnseen );
+        }
+    }
+    if ( d->sessionPreloader ) {
+        while ( d->cacheFirstUnseen && d->cacheFirstUnseen->hasResults() ) {
+            Row * r = d->cacheFirstUnseen->nextRow();
+            Mailbox * m = Mailbox::find( r->getInt( "mailbox" ) );
+            ::firstUnseenCache->insert( m, 1 + r->getBigint( "modseq" ),
+                                        r->getInt( "uid" ) );
+        }
+        if ( d->cacheFirstUnseen && !d->cacheFirstUnseen->done() )
+            return;
+        if ( !d->sessionPreloader->done() )
+            return;
+    }
+
+
     if ( !d->session ) {
         d->session = new ImapSession( imap(), d->mailbox,
-                                      d->readOnly, d->unicode,
-                                      d->mailbox->nextModSeq() );
+                                      d->readOnly, d->unicode );
         d->session->setPermissions( d->permissions );
         imap()->setSession( d->session );
     }
@@ -256,29 +291,22 @@ void Select::execute()
     else
         d->needFirstUnseen = true;
 
-    if ( d->lastModSeq < d->mailbox->nextModSeq() - 1 && !d->updated ) {
+    if ( d->lastModSeq > 0 && !d->vanished ) {
         if ( d->knownUids.isEmpty() ) {
-            d->updated = new Query( "select uid from deleted_messages "
-                                    "where mailbox=$1 and modseq > $2"
-                                    " union "
-                                    "select uid from mailbox_messages "
-                                    "where mailbox=$1 and modseq > $2",
-                                    this );
+            d->vanished = new Query( "select uid from deleted_messages "
+                                     "where mailbox=$1 and modseq >= $2",
+                                     this );
         }
         else {
-            d->updated = new Query( "select uid from deleted_messages "
-                                    "where mailbox=$1 and modseq > $2 "
-                                    "and uid=any($3)"
-                                    " union "
-                                    "select uid from mailbox_messages "
-                                    "where mailbox=$1 and modseq > $2 "
-                                    "and uid=any($3)",
-                                    this );
-            d->updated->bind( 3, d->knownUids );
+            d->vanished = new Query( "select uid from deleted_messages "
+                                     "where mailbox=$1 and modseq >= $2 "
+                                     "and uid=any($3)",
+                                     this );
+            d->vanished->bind( 3, d->knownUids );
         }
-        d->updated->bind( 1, d->mailbox->id() );
-        d->updated->bind( 2, d->lastModSeq );
-        transaction()->enqueue( d->updated );
+        d->vanished->bind( 1, d->mailbox->id() );
+        d->vanished->bind( 2, d->lastModSeq );
+        transaction()->enqueue( d->vanished );
     }
 
     if ( d->needFirstUnseen && !d->firstUnseen ) {
@@ -292,38 +320,29 @@ void Select::execute()
 
     transaction()->execute();
 
-    if ( ( d->updated && !d->updated->done() ) ||
-         ( d->firstUnseen && !d->firstUnseen->done() ) )
-        return;
-
-    if ( d->updated && !d->firstFetch ) {
-        IntegerSet s;
-        while ( d->updated->hasResults() ) {
-            Row * r = d->updated->nextRow();
-            s.add( r->getInt( "uid" ) );
-        }
-        if ( !s.isEmpty() ) {
-            d->firstFetch = new Fetch( true, false, true,
-                                       s, d->lastModSeq, imap(),
-                                       transaction() );
-            d->firstFetch->setState( Command::Executing );
-            d->session->emitUpdates( transaction() );
-        }
-    }
-    if ( d->firstFetch &&
-         d->firstFetch->state() != Finished &&
-         d->firstFetch->state() != Retired )
-        return;
-
     // emitUpdates often calls Imap::runCommands, which calls this
     // function, which will then change its state to Finished. so
     // check that and don't repeat the last few responses.
-    d->session->emitUpdates( transaction() );
     if ( state() != Executing )
         return;
 
+    d->session->emitUpdates( transaction() );
+
+    if ( d->lastModSeq > 0 && !d->firstFetch ) {
+        if ( d->knownUids.isEmpty() ) {
+            IntegerSet all;
+            all.add( 1, d->mailbox->uidnext() );
+            d->firstFetch = new Fetch( true, false, all,
+                                       d->lastModSeq, imap(), 0 );
+        } else {
+            d->firstFetch = new Fetch( true, false, d->knownUids,
+                                       d->lastModSeq, imap(), 0 );
+        }
+    }
+
     transaction()->commit();
-    if ( transaction()->state() == Transaction::Executing )
+    if ( transaction()->state() == Transaction::Inactive ||
+         transaction()->state() == Transaction::Executing )
         return;
 
     respond( "OK [UIDVALIDITY " + fn( d->session->uidvalidity() ) + "]"
@@ -354,6 +373,17 @@ void Select::execute()
             respond( "OK [ANNOTATIONS READ-ONLY] Missing 'n' right" );
     }
 
+    if ( d->vanished ) {
+        IntegerSet vanished;
+        while ( d->vanished->hasResults() ) {
+            Row * r = d->vanished->nextRow();
+            uint uid = r->getInt( "uid" );
+            vanished.add( uid );
+        }
+        if ( !vanished.isEmpty() )
+            respond( "VANISHED (EARLIER) " + vanished.set() );
+    }
+
     if ( d->session->readOnly() )
         setRespTextCode( "READ-ONLY" );
     else
diff --git b/hung_patch_from_arnt/aox/imap/imapsession.cpp a/instrumentation/aox/imap/imapsession.cpp
index 3ce295a..568e2d9 100644
--- b/hung_patch_from_arnt/aox/imap/imapsession.cpp
+++ a/instrumentation/aox/imap/imapsession.cpp
@@ -29,6 +29,7 @@ public:
     Log * l;
     IntegerSet expungesReported;
     IntegerSet expungedFetched;
+    IntegerSet changed;
     uint exists;
     uint recent;
     uint uidnext;
@@ -196,14 +197,12 @@ public:
 
 /*! Creates a new ImapSession for the Mailbox \\a m to be accessed
     using \\a imap. If \\a readOnly is true, the session is read-only.
-    If \\a unicode is true, the session presents messages in EAI
-    format, if false, in classic MIME format. If \\a previousModSeq is
-    not zero, then the ImapSession will emit flag updates starting at
-    that modseq.
+    If \\a unicode is true, the session presents messages in EAI format, if
+    false, in classic MIME format.
 */
 
 ImapSession::ImapSession( IMAP * imap, Mailbox * m, bool readOnly,
-                          bool unicode, int64 previousModSeq )
+                          bool unicode )
     : Session( m, readOnly ),
       d( new ImapSessionData )
 {
@@ -211,7 +210,6 @@ ImapSession::ImapSession( IMAP * imap, Mailbox * m, bool readOnly,
     Scope x( imap->log() );
     d->l = new Log;
     d->unicode = unicode;
-    d->cms = previousModSeq;
 }
 
 
@@ -259,6 +257,8 @@ void ImapSession::emitUpdates( Transaction * t )
         }
     }
 
+    emitFlagUpdates( t );
+
     if ( d->uidnext < uidnext() ) {
         if ( !d->existsResponse ) {
             d->existsResponse =
@@ -277,19 +277,20 @@ void ImapSession::emitUpdates( Transaction * t )
         }
     }
 
-    if ( d->nms < nextModSeq() &&
+    if ( imap()->clientSupports( IMAP::Condstore ) &&
+         d->nms < nextModSeq() &&
          !d->highestModseqResponse ) {
         d->highestModseqResponse =
             new ImapSessionData::HighestModseqResponse( this, d );
         work = true;
     }
 
-    emitFlagUpdates( t );
+    if ( d->changed.isEmpty() )
+        d->cms = d->nms;
 
     if ( work )
         d->i->unblockCommands();
     d->i->emitResponses();
-    clearUnannounced();
 
     d->emitting = false;
 }
@@ -303,13 +304,15 @@ void ImapSession::emitFlagUpdates( Transaction * t )
 {
     sendFlagUpdate();
 
-    if ( unannounced().isEmpty() )
+    if ( !d->nms )
+        return;
+    if ( d->cms >= nextModSeq() )
         return;
 
-    if ( d->cms == 0 ) {
-        d->cms = d->nms;
+    d->changed.add( unannounced().intersection( messages() ) );
+
+    if ( d->changed.isEmpty() )
         return;
-    }
 
     List<Command>::Iterator c( d->i->commands() );
     if ( !c || c->state() != Command::Executing )
@@ -338,15 +341,12 @@ void ImapSession::emitFlagUpdates( Transaction * t )
             d->ignorable.clear();
     }
 
-    Fetch * f = new Fetch( true, d->i->clientSupports( IMAP::Annotate ), false,
-                           unannounced().intersection( messages() ),
-                           d->cms - 1, d->i, t );
-    d->cms = d->nms;
-    f->setState( Command::Executing );
+    (void)new Fetch( true, d->i->clientSupports( IMAP::Annotate ),
+                     d->changed, d->cms - 1, d->i, t );
+    d->changed.clear();
 }
 
 
-
 /*! Records that \\a set was fetched while also expunged. If any
     messages in \\a set have already been recorded,
     recordExpungedFetch() summarily closes the IMAP connection.
diff --git b/hung_patch_from_arnt/aox/imap/imapsession.h a/instrumentation/aox/imap/imapsession.h
index cfb402e..c3e465d 100644
--- b/hung_patch_from_arnt/aox/imap/imapsession.h
+++ a/instrumentation/aox/imap/imapsession.h
@@ -18,7 +18,7 @@ class ImapSession
     : public Session
 {
 public:
-    ImapSession( IMAP *, Mailbox *, bool, bool = false, int64 = 0 );
+    ImapSession( IMAP *, Mailbox *, bool, bool = false );
     ~ImapSession();
 
     IMAP * imap() const;
@@ -36,8 +36,6 @@ public:
 
     bool unicode() const;
 
-    void addChangedMessage( uint );
-
 private:
     class ImapSessionData * d;
 
diff --git b/hung_patch_from_arnt/aox/message/mimefields.cpp a/instrumentation/aox/message/mimefields.cpp
index 21fe4ef..6116c9f 100644
--- b/hung_patch_from_arnt/aox/message/mimefields.cpp
+++ a/instrumentation/aox/message/mimefields.cpp
@@ -380,6 +380,10 @@ void ContentType::parse( const EString &s )
                 t = "application";
                 st = "postscript";
             }
+            else if ( s == "postscript" ) {
+                t = "application";
+                st = "postscript";
+            }
             else if ( s == "sgml" ) {
                 t = "text";
                 st = "sgml";
diff --git b/instrumentation/aox/message/tld.inc a/instrumentation/aox/message/tld.inc
new file mode 100644
index 0000000..46d7bc3
--- /dev/null
+++ a/instrumentation/aox/message/tld.inc
@@ -0,0 +1,644 @@
+{ 23, "xn--clchc0ea0b2g2a9gcd." },
+{ 18, "xn--mgberp4a5d4ar." },
+{ 18, "xn--xkc2dl3a5ee0h." },
+{ 17, "xn--xkc2al3hye2a." },
+{ 16, "xn--i1b6b1a6a2e." },
+{ 16, "xn--lgbbat1ad8j." },
+{ 16, "xn--mgba3a4f16a." },
+{ 16, "xn--mgbc0a9azcg." },
+{ 16, "xn--nqv7fs00ema." },
+{ 15, "cancerresearch." },
+{ 15, "xn--6qq986b3xl." },
+{ 15, "xn--fiq228c5hs." },
+{ 15, "xn--mgbaam7a8h." },
+{ 15, "xn--mgbayh7gpa." },
+{ 15, "xn--mgbbh1a71e." },
+{ 15, "xn--mgbx4cd0ab." },
+{ 14, "international." },
+{ 14, "xn--fpcrj9c3d." },
+{ 14, "xn--fzc2c9e2c." },
+{ 14, "xn--yfro4i67o." },
+{ 14, "xn--ygbi2ammx." },
+{ 13, "construction." },
+{ 13, "versicherung." },
+{ 13, "xn--3e0b707e." },
+{ 13, "xn--80adxhks." },
+{ 13, "xn--80asehdb." },
+{ 13, "xn--mgb9awbf." },
+{ 13, "xn--mgbab2bd." },
+{ 13, "xn--ngbc5azd." },
+{ 13, "xn--ogbpf8fl." },
+{ 12, "accountants." },
+{ 12, "blackfriday." },
+{ 12, "contractors." },
+{ 12, "engineering." },
+{ 12, "enterprises." },
+{ 12, "investments." },
+{ 12, "motorcycles." },
+{ 12, "photography." },
+{ 12, "productions." },
+{ 12, "xn--3bst00m." },
+{ 12, "xn--3ds443g." },
+{ 12, "xn--45brj9c." },
+{ 12, "xn--55qw42g." },
+{ 12, "xn--6frz82g." },
+{ 12, "xn--80ao21a." },
+{ 12, "xn--czr694b." },
+{ 12, "xn--d1acj3b." },
+{ 12, "xn--gecrj9c." },
+{ 12, "xn--h2brj9c." },
+{ 12, "xn--j6w193g." },
+{ 12, "xn--kprw13d." },
+{ 12, "xn--kpry57d." },
+{ 12, "xn--pgbs0dh." },
+{ 12, "xn--q9jyb4c." },
+{ 12, "xn--rhqv96g." },
+{ 12, "xn--s9brj9c." },
+{ 12, "xn--ses554g." },
+{ 12, "xn--zfr164b." },
+{ 11, "associates." },
+{ 11, "consulting." },
+{ 11, "creditcard." },
+{ 11, "cuisinella." },
+{ 11, "foundation." },
+{ 11, "immobilien." },
+{ 11, "industries." },
+{ 11, "management." },
+{ 11, "properties." },
+{ 11, "republican." },
+{ 11, "technology." },
+{ 11, "university." },
+{ 11, "vlaanderen." },
+{ 11, "xn--4gbrim." },
+{ 11, "xn--55qx5d." },
+{ 11, "xn--80aswg." },
+{ 11, "xn--90a3ac." },
+{ 11, "xn--cg4bki." },
+{ 11, "xn--czru2d." },
+{ 11, "xn--fiq64b." },
+{ 11, "xn--fiqs8s." },
+{ 11, "xn--fiqz9s." },
+{ 11, "xn--io0a7i." },
+{ 11, "xn--kput3i." },
+{ 11, "xn--o3cw4h." },
+{ 11, "xn--unup4y." },
+{ 11, "xn--wgbh1c." },
+{ 11, "xn--wgbl6a." },
+{ 10, "christmas." },
+{ 10, "community." },
+{ 10, "directory." },
+{ 10, "education." },
+{ 10, "equipment." },
+{ 10, "financial." },
+{ 10, "furniture." },
+{ 10, "institute." },
+{ 10, "marketing." },
+{ 10, "melbourne." },
+{ 10, "solutions." },
+{ 10, "vacations." },
+{ 10, "xn--c1avg." },
+{ 10, "xn--j1amh." },
+{ 10, "xn--l1acc." },
+{ 10, "xn--nqv7f." },
+{ 9, "airforce." },
+{ 9, "attorney." },
+{ 9, "bargains." },
+{ 9, "boutique." },
+{ 9, "brussels." },
+{ 9, "builders." },
+{ 9, "capetown." },
+{ 9, "catering." },
+{ 9, "cleaning." },
+{ 9, "clothing." },
+{ 9, "computer." },
+{ 9, "democrat." },
+{ 9, "diamonds." },
+{ 9, "discount." },
+{ 9, "engineer." },
+{ 9, "exchange." },
+{ 9, "feedback." },
+{ 9, "graphics." },
+{ 9, "holdings." },
+{ 9, "lighting." },
+{ 9, "mortgage." },
+{ 9, "partners." },
+{ 9, "pictures." },
+{ 9, "plumbing." },
+{ 9, "saarland." },
+{ 9, "services." },
+{ 9, "software." },
+{ 9, "supplies." },
+{ 9, "training." },
+{ 9, "ventures." },
+{ 9, "xn--p1ai." },
+{ 9, "yokohama." },
+{ 8, "academy." },
+{ 8, "capital." },
+{ 8, "careers." },
+{ 8, "college." },
+{ 8, "cologne." },
+{ 8, "company." },
+{ 8, "cooking." },
+{ 8, "country." },
+{ 8, "cruises." },
+{ 8, "dentist." },
+{ 8, "digital." },
+{ 8, "domains." },
+{ 8, "exposed." },
+{ 8, "finance." },
+{ 8, "fishing." },
+{ 8, "fitness." },
+{ 8, "flights." },
+{ 8, "florist." },
+{ 8, "frogans." },
+{ 8, "gallery." },
+{ 8, "guitars." },
+{ 8, "hamburg." },
+{ 8, "holiday." },
+{ 8, "kitchen." },
+{ 8, "limited." },
+{ 8, "neustar." },
+{ 8, "okinawa." },
+{ 8, "organic." },
+{ 8, "recipes." },
+{ 8, "rentals." },
+{ 8, "reviews." },
+{ 8, "schmidt." },
+{ 8, "shiksha." },
+{ 8, "singles." },
+{ 8, "support." },
+{ 8, "surgery." },
+{ 8, "systems." },
+{ 8, "website." },
+{ 7, "active." },
+{ 7, "agency." },
+{ 7, "bayern." },
+{ 7, "berlin." },
+{ 7, "camera." },
+{ 7, "career." },
+{ 7, "center." },
+{ 7, "church." },
+{ 7, "claims." },
+{ 7, "clinic." },
+{ 7, "coffee." },
+{ 7, "condos." },
+{ 7, "credit." },
+{ 7, "dating." },
+{ 7, "degree." },
+{ 7, "dental." },
+{ 7, "direct." },
+{ 7, "durban." },
+{ 7, "estate." },
+{ 7, "events." },
+{ 7, "expert." },
+{ 7, "futbol." },
+{ 7, "global." },
+{ 7, "gratis." },
+{ 7, "hiphop." },
+{ 7, "insure." },
+{ 7, "joburg." },
+{ 7, "juegos." },
+{ 7, "kaufen." },
+{ 7, "lawyer." },
+{ 7, "london." },
+{ 7, "luxury." },
+{ 7, "maison." },
+{ 7, "market." },
+{ 7, "monash." },
+{ 7, "moscow." },
+{ 7, "museum." },
+{ 7, "nagoya." },
+{ 7, "photos." },
+{ 7, "physio." },
+{ 7, "quebec." },
+{ 7, "reisen." },
+{ 7, "repair." },
+{ 7, "report." },
+{ 7, "ryukyu." },
+{ 7, "schule." },
+{ 7, "social." },
+{ 7, "supply." },
+{ 7, "suzuki." },
+{ 7, "tattoo." },
+{ 7, "tienda." },
+{ 7, "travel." },
+{ 7, "viajes." },
+{ 7, "villas." },
+{ 7, "vision." },
+{ 7, "voting." },
+{ 7, "voyage." },
+{ 7, "webcam." },
+{ 7, "yachts." },
+{ 6, "actor." },
+{ 6, "archi." },
+{ 6, "audio." },
+{ 6, "autos." },
+{ 6, "black." },
+{ 6, "build." },
+{ 6, "cards." },
+{ 6, "cheap." },
+{ 6, "citic." },
+{ 6, "codes." },
+{ 6, "dance." },
+{ 6, "deals." },
+{ 6, "email." },
+{ 6, "gives." },
+{ 6, "glass." },
+{ 6, "globo." },
+{ 6, "green." },
+{ 6, "gripe." },
+{ 6, "guide." },
+{ 6, "homes." },
+{ 6, "horse." },
+{ 6, "house." },
+{ 6, "jetzt." },
+{ 6, "koeln." },
+{ 6, "lease." },
+{ 6, "loans." },
+{ 6, "lotto." },
+{ 6, "mango." },
+{ 6, "media." },
+{ 6, "miami." },
+{ 6, "ninja." },
+{ 6, "paris." },
+{ 6, "parts." },
+{ 6, "photo." },
+{ 6, "place." },
+{ 6, "press." },
+{ 6, "rehab." },
+{ 6, "reise." },
+{ 6, "rocks." },
+{ 6, "rodeo." },
+{ 6, "shoes." },
+{ 6, "solar." },
+{ 6, "space." },
+{ 6, "tirol." },
+{ 6, "today." },
+{ 6, "tokyo." },
+{ 6, "tools." },
+{ 6, "trade." },
+{ 6, "vegas." },
+{ 6, "vodka." },
+{ 6, "watch." },
+{ 6, "works." },
+{ 5, "aero." },
+{ 5, "army." },
+{ 5, "arpa." },
+{ 5, "asia." },
+{ 5, "beer." },
+{ 5, "best." },
+{ 5, "bike." },
+{ 5, "blue." },
+{ 5, "buzz." },
+{ 5, "camp." },
+{ 5, "care." },
+{ 5, "cash." },
+{ 5, "city." },
+{ 5, "club." },
+{ 5, "cool." },
+{ 5, "coop." },
+{ 5, "desi." },
+{ 5, "fail." },
+{ 5, "farm." },
+{ 5, "fish." },
+{ 5, "fund." },
+{ 5, "gent." },
+{ 5, "gift." },
+{ 5, "guru." },
+{ 5, "haus." },
+{ 5, "host." },
+{ 5, "info." },
+{ 5, "jobs." },
+{ 5, "kiwi." },
+{ 5, "kred." },
+{ 5, "land." },
+{ 5, "life." },
+{ 5, "limo." },
+{ 5, "link." },
+{ 5, "luxe." },
+{ 5, "meet." },
+{ 5, "menu." },
+{ 5, "mini." },
+{ 5, "mobi." },
+{ 5, "moda." },
+{ 5, "name." },
+{ 5, "navy." },
+{ 5, "pics." },
+{ 5, "pink." },
+{ 5, "post." },
+{ 5, "qpon." },
+{ 5, "rest." },
+{ 5, "rich." },
+{ 5, "ruhr." },
+{ 5, "scot." },
+{ 5, "sexy." },
+{ 5, "sohu." },
+{ 5, "surf." },
+{ 5, "tips." },
+{ 5, "town." },
+{ 5, "toys." },
+{ 5, "vote." },
+{ 5, "voto." },
+{ 5, "wang." },
+{ 5, "wien." },
+{ 5, "wiki." },
+{ 5, "zone." },
+{ 4, "axa." },
+{ 4, "bar." },
+{ 4, "bid." },
+{ 4, "bio." },
+{ 4, "biz." },
+{ 4, "bmw." },
+{ 4, "bzh." },
+{ 4, "cab." },
+{ 4, "cat." },
+{ 4, "ceo." },
+{ 4, "com." },
+{ 4, "dnp." },
+{ 4, "edu." },
+{ 4, "eus." },
+{ 4, "foo." },
+{ 4, "gal." },
+{ 4, "gmo." },
+{ 4, "gop." },
+{ 4, "gov." },
+{ 4, "hiv." },
+{ 4, "ink." },
+{ 4, "int." },
+{ 4, "kim." },
+{ 4, "mil." },
+{ 4, "moe." },
+{ 4, "net." },
+{ 4, "nhk." },
+{ 4, "nrw." },
+{ 4, "nyc." },
+{ 4, "onl." },
+{ 4, "org." },
+{ 4, "ovh." },
+{ 4, "pro." },
+{ 4, "pub." },
+{ 4, "red." },
+{ 4, "ren." },
+{ 4, "rio." },
+{ 4, "scb." },
+{ 4, "soy." },
+{ 4, "tax." },
+{ 4, "tel." },
+{ 4, "uno." },
+{ 4, "vet." },
+{ 4, "wed." },
+{ 4, "wtc." },
+{ 4, "wtf." },
+{ 4, "xxx." },
+{ 4, "xyz." },
+{ 3, "ac." },
+{ 3, "ad." },
+{ 3, "ae." },
+{ 3, "af." },
+{ 3, "ag." },
+{ 3, "ai." },
+{ 3, "al." },
+{ 3, "am." },
+{ 3, "an." },
+{ 3, "ao." },
+{ 3, "aq." },
+{ 3, "ar." },
+{ 3, "as." },
+{ 3, "at." },
+{ 3, "au." },
+{ 3, "aw." },
+{ 3, "ax." },
+{ 3, "az." },
+{ 3, "ba." },
+{ 3, "bb." },
+{ 3, "bd." },
+{ 3, "be." },
+{ 3, "bf." },
+{ 3, "bg." },
+{ 3, "bh." },
+{ 3, "bi." },
+{ 3, "bj." },
+{ 3, "bm." },
+{ 3, "bn." },
+{ 3, "bo." },
+{ 3, "br." },
+{ 3, "bs." },
+{ 3, "bt." },
+{ 3, "bv." },
+{ 3, "bw." },
+{ 3, "by." },
+{ 3, "bz." },
+{ 3, "ca." },
+{ 3, "cc." },
+{ 3, "cd." },
+{ 3, "cf." },
+{ 3, "cg." },
+{ 3, "ch." },
+{ 3, "ci." },
+{ 3, "ck." },
+{ 3, "cl." },
+{ 3, "cm." },
+{ 3, "cn." },
+{ 3, "co." },
+{ 3, "cr." },
+{ 3, "cu." },
+{ 3, "cv." },
+{ 3, "cw." },
+{ 3, "cx." },
+{ 3, "cy." },
+{ 3, "cz." },
+{ 3, "de." },
+{ 3, "dj." },
+{ 3, "dk." },
+{ 3, "dm." },
+{ 3, "do." },
+{ 3, "dz." },
+{ 3, "ec." },
+{ 3, "ee." },
+{ 3, "eg." },
+{ 3, "er." },
+{ 3, "es." },
+{ 3, "et." },
+{ 3, "eu." },
+{ 3, "fi." },
+{ 3, "fj." },
+{ 3, "fk." },
+{ 3, "fm." },
+{ 3, "fo." },
+{ 3, "fr." },
+{ 3, "ga." },
+{ 3, "gb." },
+{ 3, "gd." },
+{ 3, "ge." },
+{ 3, "gf." },
+{ 3, "gg." },
+{ 3, "gh." },
+{ 3, "gi." },
+{ 3, "gl." },
+{ 3, "gm." },
+{ 3, "gn." },
+{ 3, "gp." },
+{ 3, "gq." },
+{ 3, "gr." },
+{ 3, "gs." },
+{ 3, "gt." },
+{ 3, "gu." },
+{ 3, "gw." },
+{ 3, "gy." },
+{ 3, "hk." },
+{ 3, "hm." },
+{ 3, "hn." },
+{ 3, "hr." },
+{ 3, "ht." },
+{ 3, "hu." },
+{ 3, "id." },
+{ 3, "ie." },
+{ 3, "il." },
+{ 3, "im." },
+{ 3, "in." },
+{ 3, "io." },
+{ 3, "iq." },
+{ 3, "ir." },
+{ 3, "is." },
+{ 3, "it." },
+{ 3, "je." },
+{ 3, "jm." },
+{ 3, "jo." },
+{ 3, "jp." },
+{ 3, "ke." },
+{ 3, "kg." },
+{ 3, "kh." },
+{ 3, "ki." },
+{ 3, "km." },
+{ 3, "kn." },
+{ 3, "kp." },
+{ 3, "kr." },
+{ 3, "kw." },
+{ 3, "ky." },
+{ 3, "kz." },
+{ 3, "la." },
+{ 3, "lb." },
+{ 3, "lc." },
+{ 3, "li." },
+{ 3, "lk." },
+{ 3, "lr." },
+{ 3, "ls." },
+{ 3, "lt." },
+{ 3, "lu." },
+{ 3, "lv." },
+{ 3, "ly." },
+{ 3, "ma." },
+{ 3, "mc." },
+{ 3, "md." },
+{ 3, "me." },
+{ 3, "mg." },
+{ 3, "mh." },
+{ 3, "mk." },
+{ 3, "ml." },
+{ 3, "mm." },
+{ 3, "mn." },
+{ 3, "mo." },
+{ 3, "mp." },
+{ 3, "mq." },
+{ 3, "mr." },
+{ 3, "ms." },
+{ 3, "mt." },
+{ 3, "mu." },
+{ 3, "mv." },
+{ 3, "mw." },
+{ 3, "mx." },
+{ 3, "my." },
+{ 3, "mz." },
+{ 3, "na." },
+{ 3, "nc." },
+{ 3, "ne." },
+{ 3, "nf." },
+{ 3, "ng." },
+{ 3, "ni." },
+{ 3, "nl." },
+{ 3, "no." },
+{ 3, "np." },
+{ 3, "nr." },
+{ 3, "nu." },
+{ 3, "nz." },
+{ 3, "om." },
+{ 3, "pa." },
+{ 3, "pe." },
+{ 3, "pf." },
+{ 3, "pg." },
+{ 3, "ph." },
+{ 3, "pk." },
+{ 3, "pl." },
+{ 3, "pm." },
+{ 3, "pn." },
+{ 3, "pr." },
+{ 3, "ps." },
+{ 3, "pt." },
+{ 3, "pw." },
+{ 3, "py." },
+{ 3, "qa." },
+{ 3, "re." },
+{ 3, "ro." },
+{ 3, "rs." },
+{ 3, "ru." },
+{ 3, "rw." },
+{ 3, "sa." },
+{ 3, "sb." },
+{ 3, "sc." },
+{ 3, "sd." },
+{ 3, "se." },
+{ 3, "sg." },
+{ 3, "sh." },
+{ 3, "si." },
+{ 3, "sj." },
+{ 3, "sk." },
+{ 3, "sl." },
+{ 3, "sm." },
+{ 3, "sn." },
+{ 3, "so." },
+{ 3, "sr." },
+{ 3, "st." },
+{ 3, "su." },
+{ 3, "sv." },
+{ 3, "sx." },
+{ 3, "sy." },
+{ 3, "sz." },
+{ 3, "tc." },
+{ 3, "td." },
+{ 3, "tf." },
+{ 3, "tg." },
+{ 3, "th." },
+{ 3, "tj." },
+{ 3, "tk." },
+{ 3, "tl." },
+{ 3, "tm." },
+{ 3, "tn." },
+{ 3, "to." },
+{ 3, "tp." },
+{ 3, "tr." },
+{ 3, "tt." },
+{ 3, "tv." },
+{ 3, "tw." },
+{ 3, "tz." },
+{ 3, "ua." },
+{ 3, "ug." },
+{ 3, "uk." },
+{ 3, "us." },
+{ 3, "uy." },
+{ 3, "uz." },
+{ 3, "va." },
+{ 3, "vc." },
+{ 3, "ve." },
+{ 3, "vg." },
+{ 3, "vi." },
+{ 3, "vn." },
+{ 3, "vu." },
+{ 3, "wf." },
+{ 3, "ws." },
+{ 3, "ye." },
+{ 3, "yt." },
+{ 3, "za." },
+{ 3, "zm." },
+{ 3, "zw." },
+{ 1, "." },
+
diff --git b/hung_patch_from_arnt/aox/server/eventloop.cpp a/instrumentation/aox/server/eventloop.cpp
index 6e0953f..c258e9b 100644
--- b/hung_patch_from_arnt/aox/server/eventloop.cpp
+++ a/instrumentation/aox/server/eventloop.cpp
@@ -148,6 +148,7 @@ void EventLoop::addConnection( Connection * c )
 
 void EventLoop::removeConnection( Connection * c )
 {
+    log( "Eventloop::removeConnection called", Log::Error );
     Scope x( d->log );
 
     if ( d->connections.remove( c ) == 0 )
@@ -369,7 +370,7 @@ void EventLoop::start()
                 c->log( "Still have " +
                         EString::humanNumber( c->writeBuffer()->size() ) +
                         " bytes to write", Log::Debug );
-        } catch ( const Exception& e ) {
+        } catch ( Exception e ) {
             // we don't really care at this point, do we?
         }
     }
@@ -501,7 +502,7 @@ void EventLoop::dispatch( Connection * c, bool r, bool w, uint now )
              s && s == c->writeBuffer()->size() )
             c->writeBuffer()->remove( s );
     }
-    catch ( const Exception& e ) {
+    catch ( Exception e ) {
         EString s;
         switch (e) {
         case Invariant:
@@ -557,7 +558,7 @@ void EventLoop::stop( uint s )
             else if ( s <= 1 && !c->hasProperty( Connection::Internal ) ) {
                 c->react( Connection::Shutdown );
             }
-        } catch ( const Exception& e ) {
+        } catch ( Exception e ) {
             removeConnection( c );
         }
     }
